#include <stdio.h>
#include <stdlib.h>

// display contents of vector v
void display(const double *v, const int n)
{
    for (int i = 0; i < n; i++)
        printf("%f ", *(v + i));
    puts("");
}

// bubble sort elements of v using only pointers
void bubble(const double *v, const int n)
{
    double *p, *q; // both point into v
    for (p = v + n - 1; p  >= v; p--) // from the end of vector
        for (q = v + 1; q <= p; q++) // from the begginning of vector
            if (*(q - 1) > *q)
            {  // swap values
                double t = *(q - 1);
                *(q - 1) = *q;
                *q = t;
            }
}
// Reads an arbitrary number of real values
// v = pointer to vector where to store data
// count pointer to place to store number of read elements
void readData(double **v, int *count)
{
    int nbReadOnce = 1; // number of reals read by one invovcation of scanf
    for (; nbReadOnce == 1;)
    {
        double aux;
        nbReadOnce = scanf("%lf", &aux);
        if (nbReadOnce == 1)
        {  // successful reading
            *v = realloc(*v, sizeof(double) * (*count)); // make room in vector v
            if (!*v)
            {
                fprintf(stderr, "%s: line %d no core\n", __FUNCTION__, __LINE__);
                exit(1);
            }
            *(*v + *count - 1) = aux; // place value
            printf("value read[%d]: %f\n", *count, *(*v + *count - 1));
            (*count)++;
            fflush(stdout);
        }
        else (*count)--;
    }
}

int main()
{
    double *v = (double *) malloc(sizeof(double)); // a one element vector
    if (!v)
    {
        fprintf(stderr, "%s: %d no core\n", __FUNCTION__, __LINE__);
        exit(1);
    }
    int count = 1;
    readData(&v, &count);
    display(v, count); // display vector contents
    bubble(v, count); // sort vector
    display(v, count); // display vector contents
    return 0;
}
